;
;                    Inertia Realtime 3D Rendering Engine
;    Copyright (c) 1996, Alex Chalfin, Jeroen Bouwens. All Rights Reserved.
;          DISTRIBUTION OF THIS SOURCE CODE IS STRICTLY PROHIBITED
;

;
; MATRIX.ASM
; code: Alex Chalfin
;

.486p                           ; 486 protected mode
.Model Flat,Pascal              ; with flat memory model
                                ;
                                ;
DATA SEGMENT PARA PUBLIC USE32  ;
                                ;
Public MatrixMul                ;
                                ;
ENDS                            ;
                                ;
;================================================================
; Code Segment
;================================================================
                                ;
CODE SEGMENT PARA PUBLIC USE32  ;
                                ;
;===========================================================================
; Macros
;===========================================================================

MatrixMulMacro Macro R0,A0,B0,A1,B1,A2,B2
  fld   dword ptr [esi+A0*4]    ;
  fmul  dword ptr [edi+B0*4]    ;
  fld   dword ptr [esi+A1*4]    ;
  fmul  dword ptr [edi+B1*4]    ;
  fld   dword ptr [esi+A2*4]    ;
  fmul  dword ptr [edi+B2*4]    ;
  faddp st(1),st(0)             ;
  faddp st(1),st(0)             ;
  fstp  dword ptr [ebx+R0*4]    ;
EndM

;===========================================================================
; MatrixMul
;===========================================================================
MatrixMul Proc Uses edi esi ebx,Result : DWord, Mat1 : DWord, Mat2 : DWord

  Mov  esi,DWord Ptr [Mat1]     ;
  Mov  edi,DWord Ptr [Mat2]     ;
  Mov  ebx,DWord Ptr [Result]   ;
                                ;
  MatrixMulMacro 0,0,0,1,3,2,6  ;
  MatrixMulMacro 1,0,1,1,4,2,7  ;
  MatrixMulMacro 2,0,2,1,5,2,8  ;
  MatrixMulMacro 3,3,0,4,3,5,6  ;
  MatrixMulMacro 4,3,1,4,4,5,7  ;
  MatrixMulMacro 5,3,2,4,5,5,8  ;
  MatrixMulMacro 6,6,0,7,3,8,6  ;
  MatrixMulMacro 7,6,1,7,4,8,7  ;
  MatrixMulMacro 8,6,2,7,5,8,8  ;
                                ;
  Ret                           ;
MatrixMul EndP                  ;


ENDS
END

Comment 
============================================================================
  Pascal Versions of each of the functions
============================================================================

Procedure MatrixMul(Var Result, A, B : Matrix4x3);

Begin
  Result[0] := (A[0] * B[0]) + (A[1] * B[3]) + (A[2] * B[6]);
  Result[1] := (A[0] * B[1]) + (A[1] * B[4]) + (A[2] * B[7]);
  Result[2] := (A[0] * B[2]) + (A[1] * B[5]) + (A[2] * B[8]);

  Result[3] := (A[3] * B[0]) + (A[4] * B[3]) + (A[5] * B[6]);
  Result[4] := (A[3] * B[1]) + (A[4] * B[4]) + (A[5] * B[7]);
  Result[5] := (A[3] * B[2]) + (A[4] * B[5]) + (A[5] * B[8]);

  Result[6] := (A[6] * B[0]) + (A[7] * B[3]) + (A[8] * B[6]);
  Result[7] := (A[6] * B[1]) + (A[7] * B[4]) + (A[8] * B[7]);
  Result[8] := (A[6] * B[2]) + (A[7] * B[5]) + (A[8] * B[8]);
End;





