(*

                     Inertia Realtime 3D Rendering Engine
     Copyright (c) 1996, Alex Chalfin, Jeroen Bouwens. All Rights Reserved.
           DISTRIBUTION OF THIS SOURCE CODE IS STRICTLY PROHIBITED

*)

Unit Polygon;
{$I DEFINE.INC}

Interface

Uses
  Types;

Procedure UnshadedPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure AmbientPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure LambertPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure GouraudPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure PhongPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Procedure UnshadedTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure AmbientTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure LambertTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure GouraudTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure PhongTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Procedure UnshadedPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure AmbientPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure LambertPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure GouraudPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure PhongPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Procedure UnshadedReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure AmbientReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure LambertReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure GouraudReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure PhongReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Procedure TransUnshadedPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransAmbientPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransLambertPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransGouraudPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransPhongPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Procedure TransUnshadedTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransAmbientTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransLambertTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransGouraudTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransPhongTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Procedure TransUnshadedPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransAmbientPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransLambertPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransGouraudPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransPhongPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Procedure TransUnshadedReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransAmbientReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransLambertReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransGouraudReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);
Procedure TransPhongReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);


Implementation

Uses
  Misc;

Var
  VertPtrA       : Pointer;
  VertPtrB       : Pointer;
  VertPtrC       : Pointer;

  TVA            : Pointer;
  TVB            : Pointer;
  TVC            : Pointer;

  TotalHeight    : Longint;
  TopHeight      : Longint;
  BottomHeight   : Longint;

  CeilY1         : Longint;
  CeilY2         : Longint;
  CeilY3         : Longint;

  FXDLongX       : Longint;
  FXDLongDX      : Longint;
  FXDShortX      : Longint;
  FXDShortDX     : Longint;

  FXDSide1C      : Longint;
  FXDSide1DC     : Longint;
  FXDSide2C      : Longint;
  FXDSide2DC     : Longint;

  FXDSide1U      : Longint;
  FXDSide1DU     : Longint;
  FXDSide2U      : Longint;
  FXDSide2DU     : Longint;

  FXDSide1V      : Longint;
  FXDSide1DV     : Longint;
  FXDSide2V      : Longint;
  FXDSide2DV     : Longint;

  FXDSide1S      : Longint;
  FXDSide1DS     : Longint;
  FXDSide2S      : Longint;
  FXDSide2DS     : Longint;

  FXDSide1T      : Longint;
  FXDSide1DT     : Longint;
  FXDSide2T      : Longint;
  FXDSide2DT     : Longint;

  FXDSide1Z      : Longint;
  FXDSide1DZ     : Longint;
  FXDSide2Z      : Longint;
  FXDSide2DZ     : Longint;

  FLTInten1      : Single;
  FLTInten2      : Single;
  FLTInten3      : Single;

  FLTZ1          : Single;
  FLTZ2          : Single;
  FLTZ3          : Single;


  FLTTextureX1   : Single;
  FLTTextureX2   : Single;
  FLTTextureX3   : Single;

  FLTTextureY1   : Single;
  FLTTextureY2   : Single;
  FLTTextureY3   : Single;

  FLTEnvX1       : Single;
  FLTEnvX2       : Single;
  FLTEnvX3       : Single;

  FLTEnvY1       : Single;
  FLTEnvY2       : Single;
  FLTEnvY3       : Single;

  FLTLongDX      : Single;
  FLTShortDX     : Single;

  OneOverTotalDY : Single;
  OneOverTopDY   : Single;
  OneOverBotDY   : Single;

  PolyDX         : Single;

  HorizontalDC   : Longint;
  HorizontalDU   : Longint;
  HorizontalDV   : Longint;
  HorizontalDS   : Longint;
  HorizontalDT   : Longint;
  HorizontalDZ   : Longint;

  YAddress       : DWord;
  Color          : DWord;

  UStart         : Longint;
  VStart         : Longint;
  SStart         : Longint;
  TStart         : Longint;
  SStart8        : Longint;
  TStart8        : Longint;
  CStart         : Longint;
  TextureOfsTable: Longint;
  IBufferTable   : Longint;
  Count          : Longint;
  HDU8           : Longint;
  HDV8           : Longint;
  HDS8           : Longint;
  HDT8           : Longint;


  LAffU          : Longint;
  LAffV          : Longint;
  RAffU          : Longint;
  RAffV          : Longint;
  AffDU          : Longint;
  AffDV          : Longint;
  DrawWidth      : Longint;
  SpanCount      : Longint;

  hpu            : Single;
  hpv            : Single;
  hpz            : Single;


Const
  DivTable : Array[0..16] of Single = (1.0,           1.0,
                                       0.5,           0.3333333333,
                                       0.25,          0.20,
                                       0.16666666667, 0.1428571428,
                                       0.125,         0.1111111111,
                                       0.1,           0.0909090909,
                                       0.08333333333, 0.0769230769,
                                       0.07142857142, 0.0666666667,
                                       0.0625);


Const
  _tmp_flt      : Single = 0.0;
  _tmp_half     : Single = 0.50;
  _tmp_fixone   : Single = 65536.0;
  _tmp_fxd2flt  : Single = 1.0 / 65536.0;
  _tmp_flt_63   : Single = 63.0;
  _tmp_flt_255  : Single = 255.0;
  FUDGE_FACTOR  : Single = 0.995;


{$L PLYFLSM.OBJ}
Procedure FlatPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYGOSM.OBJ}
Procedure GouraudPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYFLTX.OBJ}
Procedure FlatTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYGOTX.OBJ}
Procedure GouraudTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYPHSM.OBJ}
Procedure PhongSmoothPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYFLRE.OBJ}
Procedure FlatReflectionPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYGORE.OBJ}
Procedure GouraudReflectionPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYPHTX.OBJ}
Procedure PhongTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYPHRE.OBJ}
Procedure PhongReflectionPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYUNSM.OBJ}
Procedure UnshadedPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYUNTX.OBJ}
Procedure UnshadedTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYUNRE.OBJ}
Procedure UnshadedReflectionPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYUNSMT.OBJ}
Procedure TransUnshadedPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYFLSMT.OBJ}
Procedure TransFlatPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYGOSMT.OBJ}
Procedure TransGouraudPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYPHSMT.OBJ}
Procedure TransPhongPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYUNTXT.OBJ}
Procedure TransUnshadedTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYFLTXT.OBJ}
Procedure TransFlatTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYGOTXT.OBJ}
Procedure TransGouraudTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYPHTXT.OBJ}
Procedure TransPhongTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYUNRET.OBJ}
Procedure TransUnshadedReflectionPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYFLRET.OBJ}
Procedure TransFlatReflectionPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYGORET.OBJ}
Procedure TransGouraudReflectionPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYPHRET.OBJ}
Procedure TransPhongReflectionPolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYUNPT.OBJ}
Procedure UnshadedPerspTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYFLPT.OBJ}
Procedure FlatPerspTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYGOPT.OBJ}
Procedure GouraudPerspTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYPHPT.OBJ}
Procedure PhongPerspTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYUNPTT.OBJ}
Procedure TransUnshadedPerspTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYFLPTT.OBJ}
Procedure TransFlatPerspTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYGOPTT.OBJ}
Procedure TransGouraudPerspTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;

{$L PLYPHPTT.OBJ}
Procedure TransPhongPerspTexturePolygonASM(Poly : pTriangle; VPage : Pointer; Linesize : Longint); External;


Procedure AmbientPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  FlatPolygonASM(Poly, VPage, X);
End;


Procedure LambertPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  FlatPolygonASM(Poly, VPage, X);
End;

Procedure GouraudPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  GouraudPolygonASM(Poly, VPage, X);
End;

Procedure AmbientTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  FlatTexturePolygonASM(Poly, VPage, X);
End;

Procedure LambertTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  FlatTexturePolygonASM(Poly, VPage, X);
End;

Procedure GouraudTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  GouraudTexturePolygonASM(Poly, VPage, X);
End;

Procedure PhongPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  PhongSmoothPolygonASM(Poly, VPage, X);
End;

Procedure AmbientReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  FlatReflectionPolygonASM(Poly, VPage, X);
End;

Procedure LambertReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  FlatReflectionPolygonASM(Poly, VPage, X);
End;

Procedure GouraudReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  GouraudReflectionPolygonASM(Poly, VPage, X);
End;

Procedure PhongTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  PhongTexturePolygonASM(Poly, VPage, X);
End;

Procedure PhongReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  PhongReflectionPolygonASM(Poly, VPage, X);
End;

Procedure UnshadedPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  UnshadedPolygonASM(Poly, VPage, X);
End;

Procedure UnshadedTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  UnshadedTexturePolygonASM(Poly, VPage, X);
End;

Procedure UnshadedReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  UnshadedReflectionPolygonASM(Poly, VPage, X);
End;

Procedure TransUnshadedPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransUnshadedPolygonASM(Poly, VPage, X);
End;

Procedure TransAmbientPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransFlatPolygonASM(Poly, VPage, X);
End;

Procedure TransLambertPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransFlatPolygonASM(Poly, VPage, X);
End;

Procedure TransGouraudPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransGouraudPolygonASM(Poly, VPage, X);
End;

Procedure TransPhongPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransPhongPolygonASM(Poly, VPage, X);
End;

Procedure TransUnshadedTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransUnshadedTexturePolygonASM(Poly, VPage, X);
End;

Procedure TransAmbientTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransFlatTexturePolygonASM(Poly, VPage, X);
End;

Procedure TransLambertTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransFlatTexturePolygonASM(Poly, VPage, X);
End;

Procedure TransGouraudTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransGouraudTexturePolygonASM(Poly, VPage, X);
End;

Procedure TransPhongTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransPhongTexturePolygonASM(Poly, VPage, X);
End;

Procedure TransUnshadedReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransUnshadedReflectionPolygonASM(Poly, VPage, X);
End;

Procedure TransAmbientReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransFlatReflectionPolygonASM(Poly, VPage, X);
End;

Procedure TransLambertReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransFlatReflectionPolygonASM(Poly, VPage, X);
End;

Procedure TransGouraudReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransGouraudReflectionPolygonASM(Poly, VPage, X);
End;

Procedure TransPhongReflectionPolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransPhongReflectionPolygonASM(Poly, VPage, X);
End;

Procedure UnshadedPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  UnshadedPerspTexturePolygonASM(Poly, VPage, X);
End;

Procedure AmbientPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  FlatPerspTexturePolygonASM(Poly, VPage, X);
End;

Procedure LambertPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  FlatPerspTexturePolygonASM(Poly, VPage, X);
End;

Procedure GouraudPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  GouraudPerspTexturePolygonASM(Poly, VPage, X);
End;

Procedure PhongPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  PhongPerspTexturePolygonASM(Poly, VPage, X);
End;

Procedure TransUnshadedPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransUnshadedPerspTexturePolygonASM(Poly, VPage, X);
End;

Procedure TransAmbientPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransFlatPerspTexturePolygonASM(Poly, VPage, X);
End;

Procedure TransLambertPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransFlatPerspTexturePolygonASM(Poly, VPage, X);
End;

Procedure TransGouraudPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransGouraudPerspTexturePolygonASM(Poly, VPage, X);
End;

Procedure TransPhongPerspTexturePolygon(Poly : pTriangle; VPage : Pointer; X, Y : Longint);

Begin
  TransPhongPerspTexturePolygonASM(Poly, VPage, X);
End;


End.
